'use strict';

var fse = require('fs-extra');
// https://github.com/jprichardson/node-fs-extra
///////////////////////////////////////// FNS /////////////////

function extraMovePromisfied(src, dest, options) {
  return new Promise(function (fulfill, reject) {
    fse.move(src, dest, options, function (err) {
      if (err) return reject(err);else fulfill(dest);
    });
  });
}

function dryRunPromsie(dest) {
  return Promise.resolve(dest);
}

function errHandler(err) {
  // console.log('errHandler', err);
  throw new Error('q-mod-myfs - moveFile():  ' + err);
}

var cwd = process.cwd();

///////////////////////////////////////// MAIN /////////////////
function moveFile(src, dest) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};


  var defoultOptions = {
    dryRun: false
  };

  var extraOptions = Object.assign({}, defoultOptions, options);
  // console.log(extraOptions);
  if (extraOptions.dryRun === true) {
    return dryRunPromsie(dest);
  } else {
    return extraMovePromisfied(src, dest, extraOptions).catch(errHandler);
  }
}

module.exports = {
  moveFile: moveFile
};